import * as React from 'react';
import { TSteppableInputProps } from '../SteppableInput/SteppableInput';
import { ComponentClass } from 'react';
import { TControlProps } from '../Control/Control';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TPopoverProps } from '../Popover/Popover';
/**
 * Undefined - value is not set, null - value is force reset
 */
export declare type TDateValueProps = TControlProps<Date | null | undefined>;
export declare enum DateFormatType {
    MDY = 0,
    DMY = 1
}
export declare type TCalendarProps = TDateValueProps & {
    onMouseDown?: React.EventHandler<React.MouseEvent<Element>>;
    min?: Date;
    max?: Date;
};
export declare type TDateInputOwnProps = TSteppableInputProps & TDateValueProps & {
    min?: Date;
    max?: Date;
    calendarIcon?: React.ReactElement<any>;
    onClear?: Function;
    onFocus?: () => void;
    onBlur?: () => void;
    target?: Element;
    Calendar?: React.ComponentClass<TCalendarProps> | React.SFC<TCalendarProps>;
};
export declare type TDateDefaultProps = {
    SteppableInput: React.ComponentClass<TSteppableInputProps> | React.SFC<TSteppableInputProps>;
    ButtonIcon: React.ComponentClass<TButtonIconProps>;
    Popover: React.ComponentClass<TPopoverProps> | React.SFC<TPopoverProps>;
    dateFormatType: DateFormatType;
};
export declare type TDateInputInjectedProps = {
    theme: {
        inner?: string;
        inner_isFilled?: string;
        section?: string;
        section_isActive?: string;
        separator?: string;
        SteppableInput?: TSteppableInputProps['theme'];
        ButtonIcon?: TButtonIconProps['theme'];
        CalendarButtonIcon?: TButtonIconProps['theme'];
        Popover?: TPopoverProps['theme'];
    };
};
export declare type TDateInputFullProps = TDateInputOwnProps & TDateInputInjectedProps & TDateDefaultProps;
export declare const DATE_INPUT: symbol;
export declare type TDateInputProps = PartialKeys<TDateInputFullProps, 'theme' | 'SteppableInput' | 'ButtonIcon' | 'dateFormatType' | 'Popover'>;
export declare const DateInput: ComponentClass<TDateInputProps>;
